org.apache.hc.core5.reactor.ssl

## Interface TransportSecurityLayer

- All Known Subinterfaces:
    ProtocolIOSession

      public interface TransportSecurityLayer

  TLS capable session layer interface.
  Since:
    5.0

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `TlsDetails` | `getTlsDetails()` Gets the details of a fully established TLS session.
    `void` | `startTls(SSLContext sslContext, NamedEndpoint endpoint, SSLBufferMode sslBufferMode, SSLSessionInitializer initializer, SSLSessionVerifier verifier, Timeout handshakeTimeout)` Starts TLS session over an existing network connection with the given SSL context.
    `default void` | `startTls(SSLContext sslContext, NamedEndpoint endpoint, SSLBufferMode sslBufferMode, SSLSessionInitializer initializer, SSLSessionVerifier verifier, Timeout handshakeTimeout, FutureCallback<TransportSecurityLayer> callback)` Starts TLS session over an existing network connection with the given SSL context.

- - ### Method Detail

    - #### startTls

          void startTls(SSLContext sslContext,
                        NamedEndpoint endpoint,
                        SSLBufferMode sslBufferMode,
                        SSLSessionInitializer initializer,
                        SSLSessionVerifier verifier,
                        Timeout handshakeTimeout)
                 throws UnsupportedOperationException

      Starts TLS session over an existing network connection with the given SSL context. `NamedEndpoint` details are applicable for client side connections and are used for host name verification, when supported by the SSL engine.
      Parameters:
        `sslContext` - SSL context to be used for this session.
        `endpoint` - optional endpoint details for outgoing client side connections.
        `sslBufferMode` - SSL buffer management mode.
        `initializer` - SSL session initialization callback.
        `verifier` - SSL session verification callback.
        `handshakeTimeout` - the timeout to use while performing the TLS handshake; may be `null`.
      Throws:
        `UnsupportedOperationException` - Thrown the requested operation is not supported.

    - #### startTls

          default void startTls(SSLContext sslContext,
                                NamedEndpoint endpoint,
                                SSLBufferMode sslBufferMode,
                                SSLSessionInitializer initializer,
                                SSLSessionVerifier verifier,
                                Timeout handshakeTimeout,
                                FutureCallback<TransportSecurityLayer> callback)
                         throws UnsupportedOperationException

      Starts TLS session over an existing network connection with the given SSL context. `NamedEndpoint` details are applicable for client side connections and are used for host name verification, when supported by the SSL engine.
      Parameters:
        `sslContext` - SSL context to be used for this session.
        `endpoint` - optional endpoint details for outgoing client side connections.
        `sslBufferMode` - SSL buffer management mode.
        `initializer` - SSL session initialization callback.
        `verifier` - SSL session verification callback.
        `handshakeTimeout` - the timeout to use while performing the TLS handshake; may be `null`.
      Throws:
        `UnsupportedOperationException` - Thrown the requested operation is not supported.
      Since:
        5.2

    - #### getTlsDetails

          TlsDetails getTlsDetails()

      Gets the details of a fully established TLS session.
      Returns:
        TLS session details.

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.